#skotboot cs150 bootloader
#skot 11/11/10

import serial
import time
import sys
import argparse

#command line parsing
parser = argparse.ArgumentParser()
parser.description='Send hex files to the SkotBoot cs150 bootloader.'
parser.add_argument('-i', nargs='?', type=argparse.FileType('r'), help='send hexfile to instruction memory', metavar='hexfile', dest='imem')
parser.add_argument('-d', nargs='?', type=argparse.FileType('r'), help='send hexfile to data memory', metavar='hexfile', dest='dmem')
parser.add_argument('-e', action='store_true', help='send EOT after hex files')
parser.add_argument('-r', action='store_true', help='run sent program')
args = parser.parse_args()

if ((args.imem == None) & (args.dmem == None)):
    print >> sys.stderr, 'Must specify at least one file'
    sys.exit(-1)

#setup serial port
try:
    ser = serial.Serial('/dev/tty.KeySerial1', 57600)
except serial.SerialException:
    print >> sys.stderr, "Serial Port could not be opened"
    sys.exit(-1)
else:
    time.sleep(1)


#send imem
if args.imem:
    print 'Sending Instruction Memory Hexfile'
    ser.write('i')
    time.sleep(.05)
    for line in args.imem.readlines(8):
        ser.write(line)
        time.sleep(.01)
        #ser.readline()
    if args.e:
        #send EOT
        ser.write(chr(0x04))

#send dmem
if args.dmem:
    print 'Sending Data Memory Hexfile'
    ser.write('d')
    time.sleep(.05)
    for line in args.dmem.readlines(8):
        ser.write(line)
        time.sleep(.01)
        #ser.readline()
    if args.e:
        #send EOT
        ser.write(chr(0x04))

#run program
if args.r:
    print 'Running program...'
    ser.write('r')


